// test SINA 2003
// classe immagine, impl file

#include <fstream>
#include <string.h>
#include "immagine.h"

using namespace std;

//Se il prossimo carattere  # salta alla riga successiva
void Skip(ifstream &f)
{
	char commento[10000];
	char p;
	f>>p;
	if(p=='#')
		f.getline(commento,10000);	
	else
		f.putback(p);
}

//costruttore di default
immagine::immagine()
{
	id=P6;
	width=0;
	height=0;
	image= NULL;
}

//costruttore n_righe x n_colonne
immagine::immagine(int n_righe, int n_colonne)
{
	id=P6;
	width=n_righe;
	height=n_colonne;
	image=new Pixel[n_righe*n_colonne];
}

//costruttore dal file nomefile
immagine::immagine(char *nome_file)
{
	loadPPM(nome_file);
}

//distuttore
immagine::~immagine()
{
	if (image != NULL)
		delete[] image;
}

// funzione membro per salvare limmagine in formato PPM
bool immagine::savePPM(char *nome_file)
{
	ofstream f;
	//Scrive identifier altezza,larghezza e vpp
	if(id==P3)
	{
		//Apre il file in modalit testo
		f.open(nome_file,ios::out);
		f<<"P3"<<" ";
	}
	else
	{
		//Apre il file in modalit binaria
		f.open(nome_file,ios::binary);
		f<<"P6"<<" ";
	}
	f<<"# Immagine creata da Danilo Zampetti"<<endl;
	f<<width<<" ";
	f<<height<<" ";
	f<<255<<endl;
	//Salva l' immagine pixel per pixel
	for(int i=0;i<(height*width);i++)
	{
		if(id==P6)
		{
			f<<(char)image[i].red;
			f<<(char)image[i].green;
			f<<(char)image[i].blue;
		}
		else
		{
			f<<image[i].red<<" ";
			f<<image[i].green<<" ";
			f<<image[i].blue<<" ";
			if(i%35)
				f<<" ";
			else
				f<<endl;
		}
	}
	//Chiude il file
	f.close();
	return true;
}
// funzione membro per caricare limmagine in formato PPM
bool immagine::loadPPM(char *nome_file)
{
	int vpp;
	ifstream f;
	f.open(nome_file,ios::binary);
	if(f.fail())
		return false;
	char t_id[3];
	unsigned char c;
	
	//Legge l' identifier
	f>>t_id;
	if(!strcmp(t_id,"P6"))
		id=P6;
	else if(!strcmp(t_id,"P3"))
	{
		//Se l' immagine e P3 chiude il file perch era aperto
		//in modalit binaria e lo riapre in modalit testo
		f.close();
		f.open(nome_file,ios::in);
		f>>t_id;
		id=P3;
	}
	Skip(f);
	//I prossimi dati sono altezza, larghezza  e vpp
	f>>width;
	Skip(f);
	f>>height;
	Skip(f);
	f>>vpp;
	Skip(f);
	//Alloca spazio per l' immagine
	image=new Pixel[height*width];
	//Legge i valori pixel per pixel
	for(int i=0;i<(height*width);i++)
	{
	if(id==P6)
	{
		f.read((char *) &c,1);
		image[i].red=c;
		f.read((char *) &c,1);
		image[i].green=c;
		f.read((char *) &c,1);
		image[i].blue=c;
	}
	else
	{
		int c;
		f>>c;
		image[i].red=c;
		f>>c;
		image[i].green=c;
		f>>c;
		image[i].blue=c;
	}
	}
	//Chiude il file
	f.close();
	return true;
}

// ridimensiona loggetto
void immagine::resize(int n_righe, int n_colonne)
{
	if(image!=NULL)
		delete[] image;

	image = new Pixel [n_righe*n_colonne];
	width=n_colonne;
	height=n_righe;
}

//funzioni di get
PPMid immagine::GetID()
{
	return id;
}

int immagine::GetHeight()
{
	return height;
}

int immagine::GetWidth()
{
	return width;
}

//funzioni di set
void immagine::SetHeight(int h)
{
	resize(h,width);
}

void immagine::SetWidth(int w)
{
	resize(height,w);
}

void immagine::SetID(PPMid ident)
{
	id=ident;
}