// TEST SINA 2003.
// classe immagine, header file


#ifndef IMMAGINE_H
#define IMMAGINE_H

//Enumera i PPM identifier
enum PPMid {P3,P6};

//Struttura per contenere i pixel
struct Pixel
{
	unsigned char red;
	unsigned char green;
	unsigned char blue;
};

class immagine
{
private:
	PPMid id; //PPM identifier
	int width;//larghezza dell' immagine
	int height;//altezza dell' immagine
	
	//Vettore di pixel che conterr i dati dell' immagine
	//image  un vettore di dimensione width*height 
	Pixel *image;
public:
// costruttore di default
immagine();
// costruisce un oggetto a partire dalle dimensioni dellimmagine
immagine(int n_righe, int n_colonne);
// costruttore da file, nome_file e una stringa che identifica il
// nome del file dal quale caricare limmagine
immagine(char *nome_file);
// distruttore
~immagine();
// funzione membro per salvare limmagine in formato PPM
bool savePPM(char *nome_file);
// funzione membro per caricare limmagine in formato PPM
bool loadPPM(char *nome_file);
// ridimensiona loggetto
void resize(int n_righe, int n_colonne);
//funzioni di get
PPMid GetID();
int GetHeight();
int GetWidth();
int GetVPP();

Pixel *GetInternalPointer()
{
	return image;
}

//funzioni di set
void SetID(PPMid ident);
void SetHeight(int h);
void SetWidth(int w);
void SetVPP(int v);
};

#endif